intracdc/apps/projects/urls.py
from django.urls import path
from .views import ProjectListView, ProjectView, ProjectEditView

app_name = "projects"

urlpatterns = [
    path("", ProjectListView.as_view(), name="project-list"),
    path("<uuid:project_uuid>/", ProjectView.as_view(), name="project"),
    path(
        "<uuid:project_uuid>/edit/",
        ProjectEditView.as_view(),
        name="project-edit",
    ),
]

intracdc/urls.py
from rest_framework.decorators import api_view
from rest_framework.response import Response
from rest_framework.reverse import reverse

from django.conf import settings
from django.contrib import admin
from django.urls import include, path


# pylint: disable=redefined-builtin
@api_view(["GET"])
def api_root(request, format=None):
    return Response(
        {
            "accounts": reverse(
                "api_accounts:api-root", request=request, format=format
            ),
            "projects": reverse(
                "api_projects:api-root", request=request, format=format
            ),
            "themes": reverse(
                "api_themes:api-root", request=request, format=format
            ),
        }
    )


urlpatterns = [
    path("admin/", admin.site.urls),
    path("markdownx/", include("markdownx.urls")),
    path("api/", api_root),
    path(
        "api/accounts/", include("accounts.api_urls", namespace="api_accounts")
    ),
    path(
        "api/projects/", include("projects.api_urls", namespace="api_projects")
    ),
    path("api/themes/", include("themes.api_urls", namespace="api_themes")),
    path(
        "api-auth/", include("rest_framework.urls", namespace="rest_framework")
    ),
    path("", include("home.urls", namespace="home")),
    path("accounts/", include("accounts.urls", namespace="accounts")),
    path("accounts/", include("social_django.urls", namespace="social")),
    path("projects/", include("projects.urls", namespace="projects")),
]

if settings.DEBUG:
    import debug_toolbar

    urlpatterns = [
        path("__debug__/", include(debug_toolbar.urls))
    ] + urlpatterns

intracdc/apps/projects/models.py
import uuid
from markdownx.models import MarkdownxField

from django.contrib.auth import get_user_model
from django.db import models
from django.db.models import Q
from django.utils import timezone

from intracdc.conf.storage_backends import PrivateMediaStorage

from accounts.models import Class, Semester, Account

from .utils import SafeDict


class ProjectQuerySet(models.QuerySet):
    def by_semester(self, semester: Semester):
        return self.filter(semester=semester)

    def by_class(self, classe: Class):
        return self.by_semester(classe.semester)

    def by_user(self, user: Account):
        if user.is_superuser:
            return self

        filter_query = Q(managers__username=user.username)

        if user.current_class is None and user.past_classes.count() == 0:
            return self.filter(filter_query)

        if user.current_class is not None:
            filter_query |= Q(semester=user.current_class.semester)
        for past_class in user.past_classes.all():
            filter_query |= Q(semester=past_class.semester)

        query = self.filter(filter_query)

        if user.is_student():
            query = query.published()

        return query

    def published(self):
        now = timezone.now()
        return self.filter(begin__gte=now)

    def unpublished(self):
        now = timezone.now()
        return self.filter(begin__lte=now)

    def ongoing(self):
        now = timezone.now()
        return self.filter(begin__gte=now, end__lte=now)


class Project(models.Model):
    class ProjectType(models.TextChoices):
        OCAML = "ML", "OCaml"
        CSHARP = "CS", "C Sharp"

    uuid = models.UUIDField(
        primary_key=True, default=uuid.uuid4, editable=False
    )

    number = models.IntegerField()
    type = models.CharField(max_length=2, choices=ProjectType.choices)
    title = models.CharField(max_length=255)
    semester = models.ForeignKey("accounts.Semester", on_delete=models.PROTECT)
    managers = models.ManyToManyField(
        get_user_model(),
        limit_choices_to={"groups__name__in": ["ACDC", "Teachers", "CRI"]},
    )

    description = MarkdownxField(blank=True)

    begin = models.DateTimeField()
    end = models.DateTimeField()

    custom_git_url = models.CharField(max_length=255, blank=True)

    objects = ProjectQuerySet.as_manager()

    def compute_git_url(self, user):
        if not user.is_authenticated:
            return ""
        if len(self.custom_git_url) != 0:
            return self.custom_git_url.format_map(
                SafeDict(login=user.username)
            )
        return (
            f"git@git.cri.epita.fr:p/"
            f"{ self.semester.promotion }-s{ self.semester.number }"
            f"{ 's' if self.semester.is_sharp else '' }-tp/"
            f"{ 'caml'if self.type == 'ML' else 'csharp' }-"
            f"tp{ self.number }-{ user.username }"
        )

    def is_unpublished(self):
        return timezone.now() < self.begin

    def is_published(self):
        return self.begin <= timezone.now()

    def is_ongoing(self):
        now = timezone.now()
        return self.begin <= now() < self.end

    def is_finished(self):
        return self.end <= timezone.now()

    def __str__(self):
        return f"{self.semester} - {self.type} - {self.number} - {self.title}"


class ProjectFileQuerySet(models.QuerySet):
    def by_project(self, project: Project):
        return self.filter(project=project)

    def by_user(self, user: Account):
        return self.filter(project__in=Project.objects.by_user(user))


class ProjectFile(models.Model):
    class FileType(models.TextChoices):
        SUBJECT_FR = "FR", "French subject"
        SUBJECT_EN = "EN", "English subject"
        SKELETON = "SK", "Skeleton"
        CORRECTION = "CR", "Correction"
        OTHER = "OT", "Other"

    uuid = models.UUIDField(
        primary_key=True, default=uuid.uuid4, editable=False
    )
    project = models.ForeignKey("Project", on_delete=models.CASCADE)
    file = models.FileField(storage=PrivateMediaStorage())

    type = models.CharField(max_length=2, choices=FileType.choices)
    type_other_description = models.CharField(max_length=255, blank=True)

    is_private = models.BooleanField(default=True)

    version_major = models.IntegerField()
    version_minor = models.IntegerField(default=0)
    version_patch = models.IntegerField(default=0)
    version_build = models.IntegerField(default=0)

    uploaded_by = models.ForeignKey(get_user_model(), on_delete=models.PROTECT)
    uploaded_at = models.DateTimeField(auto_now_add=True)

    objects = ProjectFileQuerySet.as_manager()

    def get_version(self):
        return f"{self.version_major}.{self.version_minor}.{self.version_patch}.{self.version_build}"  # noqa: E501

    # pylint:disable=signature-differs
    def delete(self, *args, **kwargs):
        self.file.delete(False)
        return super(ProjectFile, self).delete(*args, **kwargs)

    def __str__(self):
        return f"{self.file}"

intracdc/apps/projects/forms.py
from django import forms

from .models import Project


class ProjectEditForm(forms.ModelForm):
    class Meta:
        model = Project
        fields = [
            "title",
            "description",
        ]

intracdc/apps/projects/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.exceptions import PermissionDenied
from django.shortcuts import get_object_or_404, render, redirect
from django.views.generic import TemplateView

from .forms import ProjectEditForm
from .models import Project


class ProjectListView(LoginRequiredMixin, TemplateView):
    template_name = "projects/project-list.html"

    def get(self, request, *args, **kwargs):
        return render(request, self.template_name, {})


class ProjectView(LoginRequiredMixin, TemplateView):
    template_name = "projects/project.html"

    def get(self, request, *args, **kwargs):
        project = get_object_or_404(Project, uuid=kwargs["project_uuid"])
        context = {
            "project": project,
        }

        return render(request, self.template_name, context)


class ProjectEditView(LoginRequiredMixin, TemplateView):
    template_name = "projects/project-edit.html"

    def get(self, request, *args, **kwargs):
        project = get_object_or_404(Project, uuid=kwargs["project_uuid"])

        if (
            not request.user.is_superuser
            and request.user not in project.managers.all()
        ):
            raise PermissionDenied

        context = {
            "project": project,
            "form": ProjectEditForm(instance=project),
        }
        return render(request, self.template_name, context)

    # pylint:disable=unused-argument
    def post(self, request, *args, **kwargs):
        project = get_object_or_404(Project, uuid=kwargs["project_uuid"])

        if (
            not request.user.is_superuser
            and request.user not in project.managers.all()
        ):
            raise PermissionDenied

        form = ProjectEditForm(request.POST, instance=project)
        if form.is_valid():
            edited_project = form.save()
            edited_project.save()
            return redirect("projects:project", project_uuid=project.uuid)
        context = {
            "project": project,
            "form": form,
        }
        return render(request, self.template_name, context)

intracdc/apps/projects/templates/projects/project-edit.html
{% extends "base.html" %}

{% block content %}
<vstack spacing="s">
  <hstack responsive spacing="s">
    <div class="pa2 bg-background-alt br-pill" style="text-align: center;">{{ project.semester }}</div>
    <div class="pa2 bg-background-alt br-pill" style="text-align: center;">{{ project.get_type_display }}</div>
    <div class="pa2 bg-background-alt br-pill" style="text-align: center;">{{ project.number }}</div>
    <h2 stretch>{{ project.title }}</h2>
    <div class="pa2 bright br-pill" style="background-color: #fc2222; text-align: center;">Finished</div>
    <div class="pa2 bright br-pill" style="background-color: #ffa500; text-align: center;">Ongoing</div>
    <div class="pa2 bright br-pill" style="background-color: #909090; text-align: center;">Unpublished</div>
    <div class="pa2 bg-background-alt br3" style="text-align: center;"><a href={% url "projects:project" project.uuid %}>Cancel</a></div>
  </hstack>
  <hr>

  <form method="post" enctype="multipart/form-data">
    {% csrf_token %}
    <vstack responsive spacing="m">
      {{ form.as_p }}
    </vstack>
    <br />
    <input type="submit" value="Save">
  </form>
  {{ form.media }}
</vstack>
{% endblock %}

intracdc/apps/projects/templates/projects/project-list.html
{% extends 'base.html' %}

{% block content %}
<vstack spacing="m" id="app">
  <vstack class="overflow-x" spacing="s">
    <h2>Projects</h2>
    <hr>

    <section v-if="errored">
      <hstack stretch responsive align-x="center">
        <div class="pa3 br3" style="background-color: #fc2222;">
          We're sorry, we're not able to retrieve this information at the moment, please try back later.
        </div>
      </hstack>
    </section>

    <section v-else>
      <vstack stretch align-x="center" align-y="center" v-if="loading">
        <div class="loader"></div>
      </vstack>

      <vstack v-else>
        <table>
          <thead>
            <tr>
              <th>Semester</th>
              <th>Type</th>
              <th>#</th>
              <th>Project</th>
              <th>Deadline</th>
              <th>Status</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="project in projects">
              <td>${ project.semester.display_name }</td>
              <td>${ project.type_display }</td>
              <td>${ project.number }</td>
              <td><a :href="`/projects/${ project.uuid }`">${ project.title }</a></td>
              <td>${ project.end.toLocaleString("fr").replace("à ", "") }</td>
              <td v-if="project.end <= now"><div class="pa1 bright br-pill" style="background-color: #fc2222; text-align: center;">Finished</div></td>
              <td v-if="project.begin <= now && now < project.end"><div class="pa1 bright br-pill" style="background-color: #ffa500; text-align: center;">Ongoing</div></td>
              <td v-if="now < project.begin"><div class="pa1 bright br-pill" style="background-color: #909090; text-align: center;">Unpublished</div></td>
            </tr>
          </tbody>
        </table>
      </vstack>
    </section>
  </vstack>
</vstack>

<script>
  new Vue({
    delimiters: ["${", "}"],
    el: "#app",
    data() {
      return {
        projects: [],
        now: new Date(),
        loading: true,
        errored: false,
      }
    },

    mounted() {
      this.intervalFetchData();
    },

    methods: {
      fetchData: async function() {
        this.loading = true;
        this.errored = false;

        var response = await axios.get("/api/projects/projects/")
          .catch(error => {
            console.log(error);
            this.errored = true;
            this.loading = false;
          });
        this.projects = response.data["results"];
        this.projects.forEach(async function(project, index) {
          var response = await axios.get(project.semester);
          project.semester = response.data;
          project.begin = new Date(project.begin);
          project.end = new Date(project.end);
        });

        this.now = new Date();
        this.loading = false;
      },

      intervalFetchData: function() {
        this.fetchData();
        setInterval(() => {
          this.fetchData()
        }, 5000);
      },
    },
  })
</script>
{% endblock %}

intracdc/apps/projects/templates/projects/project.html
{% extends 'base.html' %}

{% block content %}
<vstack spacing="s" id="app">
  <section v-if="errored">
    <hstack stretch responsive align-x="center">
      <div class="pa3 br3" style="background-color: #fc2222;">
        We're sorry, we're not able to retrieve this information at the moment, please try back later.
      </div>
    </hstack>
  </section>

  <section v-else>
    <vstack stretch align-x="center" align-y="center" v-if="loading">
      <div class="loader"></div>
    </vstack>

    <vstack v-else spacing="s">
      <hstack responsive spacing="s">
        <div class="pa2 bg-background-alt br-pill" style="text-align: center;">${ project.semester.display_name }</div>
        <div class="pa2 bg-background-alt br-pill" style="text-align: center;">${ project.type_display }</div>
        <div class="pa2 bg-background-alt br-pill" style="text-align: center;">${ project.number }</div>
        <h2 stretch>${ project.title }</h2>

        <div v-if="project.end <= now" class="pa2 bright br-pill" style="background-color: #fc2222; text-align: center;">Finished</div>
        <div v-if="project.begin <= now && now < project.end" class="pa2 bright br-pill" style="background-color: #ffa500; text-align: center;">Ongoing</div>
        <div v-if="now < project.begin" class="pa2 bright br-pill" style="background-color: #909090; text-align: center;">Unpublished</div>

        <div v-if="can_edit" class="pa2 bg-background-alt br3" style="text-align: center;"><a :href="`/projects/${ project.uuid }/edit/`">Edit</a></div>
      </hstack>
      <hr>

      <div class="pa3 bg-link background-alt br3">
        <hstack responsive>
          <p stretch>Start: ${ project.begin.toLocaleString("fr").replace("à ", "") }</p>
          <p stretch>End: ${ project.end.toLocaleString("fr").replace("à ", "") }</p>
        </hstack>
      </div>

      <vstack responsive class="bg-background br3">
        <aside v-html="project.rendered_description" stretch class="pa3"></aside>
      </vstack>

      <hstack responsive spacing="s" class="bg-background-alt pa3 br3">
        <aside stretch class="pa3">
          <vstack responsive>
            <h5>Project files</h5>
            <table>
              <thead>
                <tr>
                  <th>File</th>
                  <th>Version</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="file in project_files">
                  <td><a :href="`${ file.file }`" target="_blank">${ file.type_display }</a></td>
                  <td>${ file.version }</td>
                </tr>
              </tbody>
            </table>
          </vstack>
        </aside>
      </hstack>

      <hstack responsive spacing="s" class="bg-background-alt pa3 br3">
        <aside stretch class="pa3">
          <vstack responsive>
            <h5>Project managers</h5>
            <ul>
              <li v-for="manager in project.managers" style="word-break: break-all;">
                <a :href="`/accounts/profile/${ manager.username }`">${ manager.username }</a>
              </li>
            </ul>
          </vstack>
        </aside>
        <aside stretch class="pa3">
          <vstack responsive>
            <h5>Submission</h5>
            <code>${ project.git_url }</code>
          </vstack>
        </aside>
      </hstack>
    </vstack>
  </section>
</vstack>

<script>
  new Vue({
    delimiters: ["${", "}"],
    el: "#app",
    data() {
      return {
        project: {
          title: "",
        },
        project_files: [],
        can_edit: false,
        now: new Date(),

        loading: true,
        errored: false,
      }
    },

    mounted() {
      this.intervalFetchData();
    },

    methods: {
      fetchData: async function() {
        this.loading = true;
        this.errored = false;

        var response = await axios.get("/api/projects/projects/{{ project.uuid }}/")
          .catch(error => {
            console.log(error);
            this.errored = true;
            this.loading = false;
          });
        this.project = response.data;
        var response = await axios.get(this.project.semester);
        this.project.semester = response.data;
        this.project.begin = new Date(this.project.begin);
        this.project.end = new Date(this.project.end);
        managers = []
        this.project.managers.forEach(async function(manager, index) {
          var response = await axios.get(manager);
          managers.push(response.data);
        });
        this.project.managers = managers;

        var response = await axios.get("/api/projects/projects/{{ project.uuid }}/projectfiles/")
          .catch(error => {
            console.log(error);
            this.errored = true;
            this.loading = false;
          });
        this.project_files = response.data["results"];

        this.now = new Date();
        this.loading = false;
      },

      intervalFetchData: function() {
        this.fetchData();
        setInterval(() => {
          this.fetchData()
        }, 5000);
      },
    },
  })
</script>
{% endblock %}